Attribute VB_Name = "modOLE"
Option Explicit

'#include <modGetPutMem>

'      OLE.
'  modGetPutMem

'(c) GSerg, 2004


',    StrPtr
Private Declare Function CLSIDFromString Lib "ole32" (ByVal lpsz As Long, pclsid As modOLE.GUID) As Long
Private Declare Function IIDFromString Lib "ole32" (ByVal lpsz As Long, lpiid As modOLE.GUID) As Long

Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

Public Declare Sub OleInitialize Lib "ole32" (pvReserved As Any)
Public Declare Sub OleUninitialize Lib "ole32" ()
Public Declare Function CoCreateInstance Lib "ole32" (CreateWhat As modOLE.GUID, ByVal pUnkOuter As Long, ByVal dwClsContext As Long, ReturnWhichInterface As modOLE.GUID, ppResult As Any) As Long

Private Const NOERROR As Long = 0
Private Const S_OK As Long = 0
Private Const CO_E_CLASSSTRING As Long = &H800401F3
Private Const E_INVALIDARG As Long = &H80070057
Private Const REGDB_E_WRITEREGDB As Long = &H80040151
Private Const E_OUTOFMEMORY As Long = &H8007000E

Public Type GUID
  Data1 As Long
  Data2 As Integer
  Data3 As Integer
  Data4(0 To 7) As Byte
End Type

Public Const unk_QueryInterface As Long = 0
Public Const unk_AddRef As Long = 1
Public Const unk_Release As Long = 2

Public Const E_NOINTERFACE As Long = &H80004002

Public Const IID_IUnknown As String = "00000000-0000-0000-C000-000000000046"
Public Const IID_IDispatch As String = "00020400-0000-0000-C000-000000000046"

Public Function ClassID(GUIDString As String) As modOLE.GUID
  Select Case CLSIDFromString(StrPtr(GUIDString), ClassID)
  Case E_INVALIDARG, CO_E_CLASSSTRING
    Err.Raise 5
  Case REGDB_E_WRITEREGDB
    Err.Raise 432
  End Select
End Function

Public Function InterfaceID(GUIDString As String) As modOLE.GUID
  Select Case IIDFromString(StrPtr(GUIDString), InterfaceID)
  Case E_INVALIDARG
    Err.Raise 5
  Case E_OUTOFMEMORY
    Err.Raise 7
  End Select
End Function

Public Function CallInterface(ByVal pInterface As Long, ByVal Member As Long, ByVal ParamsCount As Long, Optional ByVal p1 As Long = 0, Optional ByVal p2 As Long = 0, Optional ByVal p3 As Long = 0, Optional ByVal p4 As Long = 0, Optional ByVal p5 As Long = 0, Optional ByVal p6 As Long = 0, Optional ByVal p7 As Long = 0, Optional ByVal p8 As Long = 0, Optional ByVal p9 As Long = 0, Optional ByVal p10 As Long = 0) As Long
  '   ...
  Dim t As Long, hGlobal As Long
  
  Const GMEM_FIXED As Long = &H0
  
  If ParamsCount < 0 Then Err.Raise 5 'invalid call
  If pInterface = 0 Then Err.Raise 5
  
  hGlobal = GlobalAlloc(GMEM_FIXED, 32)
  If hGlobal = 0 Then Err.Raise 7 'insuff. memory
  
  ' 
  PutMem1 hGlobal, &HB9
  PutMem1 hGlobal + 5, &HB8
  PutMem8 hGlobal + 10, &HF98349, &H34FF057C
  PutMem4 hGlobal + 18, &HF5EB88
  PutMem1 hGlobal + 21, &HE8
  PutMem4 hGlobal + 26, &H10C2&      'ret 0x0010
  
  PutMem4 hGlobal + 1, ParamsCount + 1
  PutMem4 hGlobal + 6, VarPtr(p1) - 4
  
  GetMem4 pInterface, VarPtr(t)     ':   vTable
  GetMem4 t + Member * 4, VarPtr(t) '  vTable,    
  PutMem4 hGlobal + 22, t - (hGlobal + 22) - 4
  
  ParamsCount = pInterface
  CallInterface = CallWindowProc(hGlobal, 0, 0, 0, 0)
  
  GlobalFree hGlobal
End Function
